var Cus00109_CustoPlanejadoDoCardapioTipoDePratoController = function(ScreenService, General, restEngine, GeneralServices, templateManager) {
	/*global getLocalVar moment Configuration*/
	var self = this;

	var intervaloDefault = function() {
		var dataProcessamento = getLocalVar('DTPROCESSA');

		if (dataProcessamento !== undefined && dataProcessamento !== "" && dataProcessamento !== null) {
			return dataProcessamento;
		} else {
			dataProcessamento = moment().format('DD/MM/YYYY');
			return dataProcessamento;
		}
	};

	this.onEnter = function(widget) {
		if (!widget.currentRow.REPORT_NAME) {
			widget.newRow();
		}

		var currentRow = widget.currentRow;
		widget.applyDefaultValue();

		GeneralServices.retornaTipoCustoPadrao(getLocalVar('CDFILIAL')).then(function(callback) {
			currentRow.NMTIPOCUSTO = callback.dataset.defaulttipocusto[0].NMTIPOCUSTO;
			currentRow.CDTIPOCUSTO = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
		});
		
		var defaultDateInterval = intervaloDefault();
		
		widget.getField('DTINTERVAL').defaultValue = {
			start: defaultDateInterval,
			end: defaultDateInterval
		};
	};

	this.filtraFiliais = function(widget) {
		let cdgrupfili = 'T';

		widget.getField('NMFILIAL').clearValue();
		widget.getField('CDSERVFILI').applyDefaultValue();
		widget.getField('CDSERVFILI').dataSourceFilter = [];

		if (widget.getField('NMGRUPFILI').value()) {
			cdgrupfili = widget.currentRow.CDGRUPFILI;
		} else {
			widget.currentRow.CDGRUPFILI = 'T';
		}

		widget.getField('NMFILIAL').dataSourceFilter = [
			{
				name: "CDGRUPFILI",
				operator: "=",
				value: cdgrupfili
		    },
			{
				name: "CDOPERADOR",
				operator: "=",
				value: getLocalVar('CDOPERADOR')
		    }
	    ];

		widget.getField('NMFILIAL').reload();
	};

	this.onChangeUnity = function(args) {
		var field = args.owner.field;
		var widget = field.widget;

		widget.getField('CDSERVFILI').setValue([]);
		if (!field.value()) {
			widget.currentRow.CDFILIAL = '';
		}
	};

	this.atualizaListaDeServico = function(widget) {
		let grupoServicos = '';
		let filiais = '';
		let currentRow = widget.currentRow;
		let cdgrupfili = widget.currentRow.CDGRUPFILI;

		if (currentRow.ALLGRUPSERV == 'N') {
			if (currentRow.CDGRUPSERV.length) {
				grupoServicos = currentRow.CDGRUPSERV.join('_');
			} else {
				grupoServicos = '';
			}
		} else {
			grupoServicos = 'T';
		}

		if (currentRow.ALLFILIAL == 'N') {
			if (currentRow.NMFILIAL.length) {
				filiais = currentRow.NMFILIAL.join('_');
			} else {
				filiais = '';
			}
		} else {
			filiais = 'T';
		}

		if (!cdgrupfili) {
			cdgrupfili = "T";
		}

		widget.getField('CDSERVFILI').dataSourceFilter = [
			{
				name: "CDGRUPSERV",
				operator: "=",
				value: grupoServicos
		    },
			{
				name: "CDGRUPFILI",
				operator: "=",
				value: cdgrupfili
		    },
			{
				name: "CDFILIAL",
				operator: "=",
				value: filiais
		    },
			{
				name: "NRORG",
				operator: "=",
				value: getLocalVar('NRORG')
		    },
			{
				name: "CDOPERADOR",
				operator: "=",
				value: getLocalVar('CDOPERADOR')
		    }
	    ];

		widget.getField('CDSERVFILI').reload();
	};

	function concatenaColunaArray(array, separador, coluna) {
		var colunaConcatenada = '';
		if (coluna) {
			var newArray = array.map(function(row) {
				return row[coluna];
			});
			colunaConcatenada = newArray.length ? newArray.join(separador) : '';
		} else {
			colunaConcatenada = array.length ? array.join(separador) : '';
		}
		
		return colunaConcatenada;
	}
	
	function getServDataSource(NMFILIAL, CDGRUPSERV, CDGRUPFILI) {
		return General.callRestEngine("cus#/servicos_por_agrupfili_multi_filiais", "FilterData", [
			{
	            "name": "CDOPERADOR",
	            "operator": "=",
	            "value": getLocalVar('CDOPERADOR')
	        },
	        {
	            "name": "CDGRUPFILI",
	            "operator": "=",
	            "value": CDGRUPFILI
	        },
	        {
	            "name": "CDFILIAL",
	            "operator": "=",
	            "value": NMFILIAL
	        },
	        {
	            "name": "CDGRUPSERV",
	            "operator": "=",
	            "value": Array.isArray(CDGRUPSERV) ? CDGRUPSERV.join('_') : CDGRUPSERV
	        },
	        {
	            "name": "NRORG",
	            "operator": "=",
	            "value": getLocalVar('NRORG')
	    	}
	    ]);
	}

	 this.verificaCheckboxTodos = function(currentRow) {
	 	let promise;
	 	
	 	currentRow.LISTASERVFILI = undefined;
	 	currentRow.CDGRUPSERV = currentRow.ALLGRUPSERV == 'S' ? 'T' : currentRow.CDGRUPSERV;
	 	currentRow.CDGRUPFILI = currentRow.CDGRUPFILI == undefined ? 'T' : currentRow.CDGRUPFILI;
	 	
		if (currentRow.ALLSERVFILI == 'N') {
			currentRow.LISTASERVFILI = currentRow.CDSERVFILI.map(s => s.CDFILIAL+s.CDSERVFILI);
		}else if(currentRow.ALLFILIAL == 'N') {
			promise = getServDataSource(currentRow.NMFILIAL.join(), currentRow.CDGRUPSERV, currentRow.CDGRUPFILI);
		}else {
			promise = getServDataSource('T', currentRow.CDGRUPSERV, currentRow.CDGRUPFILI);
		}

		if (currentRow.TCDTIPOPRAT == 'T') {
			currentRow.LISTATIPOPRAT = 'x';
			currentRow.TCDTIPOPRAT = 'T';
		} else {
			currentRow.LISTATIPOPRAT = concatenaColunaArray(currentRow.CDTIPOPRAT, "_");
			currentRow.TCDTIPOPRAT = 'x';
		}
		
		return promise;
	};

	this.validacaoCampos = function(widget) {

		var reportName = widget.currentRow.REPORT_NAME;

		var reportFormats = [
			{
				name: "pdf",
				value: "PDF"
			},
			{
				name: "xlsx",
				value: "XLSX"
			}
		];

		if (widget.isValid()) {
			widget.currentRow.DTINICIAL = widget.currentRow.DTINTERVAL.formattedStart;
			widget.currentRow.DTFINAL = widget.currentRow.DTINTERVAL.formattedEnd;
			widget.currentRow.CDPICTPRAT = getLocalVar('CDPICTPRAT').replace(/[^(/\.|\ )]/g, "@");
			widget.currentRow.CDPICTPROD = getLocalVar("CDPICTPROD").replace(/[^(/\.|\ )]/g, "@");
			General.openReportPopup(widget, this.abreRelatorio, [widget, reportName], reportFormats);
		}

	};

	this.abreRelatorio = function(widget, reportName) {
		if (widget.isValid()) {
			let a = self.verificaCheckboxTodos(widget.currentRow);
			if(widget.currentRow.LISTASERVFILI == undefined) {
				a.then((callback) => {
					widget.currentRow.LISTASERVFILI = callback.dataset.servicos_por_agrupfili_multi_filiais.map(s => s.CDFILIAL+s.CDSERVFILI);
					General.openReport('cus_relatorio#/cus00109_custo_planejado_do_cardapio_por_tipo_de_prato', reportName, widget.currentRow);
				});
			}else {
				General.openReport('cus_relatorio#/cus00109_custo_planejado_do_cardapio_por_tipo_de_prato', reportName, widget.currentRow);
			}
		}
	}.bind(this);

	this.retornaServicos = function(args) {
		General.onClickDependentField(args.owner.field, {
			CDFILIAL: args.owner.field.widget.currentRow.ALLFILIAL == 'S' ? 'T' : args.owner.field.widget.currentRow.CDFILIAL,
			CDGRUPSERV: self.retornaGrupoDeServico(args.owner.field.widget.currentRow)
		});
	};

	this.clearCurrentRow = function(args) {
		if (templateManager.container.getWidget('cus00109').getField('NMFILIAL').value() == '') {
			args.owner.field.widget.currentRow.CDFILIAL = '';
		}
	};
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus00109_CustoPlanejadoDoCardapioTipoDePratoController', Cus00109_CustoPlanejadoDoCardapioTipoDePratoController);
});
